package funktiopiirturi;

import javax.swing.*;
import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;


/**
 * Funktioiden piirtopaneeli, joka sislt  koordinaatiston, johon funktiot piirretn,
 * sek hallintapaneelin suurentamista, kuvan tyhjentmist yms. toimintoja varten.
 *
 */
public class FunctionShowPanel extends JPanel implements ActionListener {
	final static long serialVersionUID = 1L;		// varoitukset pois
	private SurfaceXY drawSurface;					// funktioiden XY-piirtopinta
	private JLabel zoomFieldX, zoomFieldY;			// suurennoksen nyttkentt
	private JButton zoomInX, zoomOutX;				// suurennosnapit x-akselille
	private JButton zoomInY, zoomOutY;				//       "        y-akselille
	private JCheckBox keepRatio;					// kuvasuhteen silytyksen valitaruutu
	private JButton clear, reset;					// muut hallintanapit
	private JPanel controlPanel;					// hallintapaneeli
	//private Funktiopiirturi parent;					// koko funktiopiirturi
	
	/**
	 * Funktioiden piirtopaneelin konstruktori rakentaa kyseisen hsskn.
	 */
	public FunctionShowPanel(Funktiopiirturi parent) {
	//public FunctionShowPanel(Funktiopiirturi parent) {
		//this.parent = parent;
			
		// Funktioiden piirtopinta
		this.drawSurface = new SurfaceXY();
		this.drawSurface.setMaximumSize(new Dimension(Short.MAX_VALUE, Short.MAX_VALUE));
		this.drawSurface.setPreferredSize(new Dimension(Short.MAX_VALUE, Short.MAX_VALUE));
		this.drawSurface.setMinimumSize(new Dimension(32, 32));
		this.drawSurface.setAlignmentY(Component.TOP_ALIGNMENT);
		//this.drawSurface.setBorder(BorderFactory.createLineBorder(Color.black));
		
//		this.drawSurface.addFunction(new FuncXtoY("x ^ 2 - x - 2"));
//		this.drawSurface.addFunction(new FuncXtoY("x ^ 3"));
//		this.drawSurface.addFunction(new FuncXtoY("sin x"));
//		this.drawSurface.addFunction(new FuncXtoY("exp (.2*x)"));
		
		// Suurennos-/pienennsnapit
		this.zoomOutX = new JButton("-");
		this.zoomOutX.addActionListener(this);
		this.zoomInX = new JButton("+");
		this.zoomInX.addActionListener(this);
		
		this.zoomOutY = new JButton("-");
		this.zoomOutY.addActionListener(this);
		this.zoomInY = new JButton("+");
		this.zoomInY.addActionListener(this);
		
		// Suurennos-kentt
		this.zoomFieldX = new JLabel();
		this.zoomFieldX.setText(""+this.drawSurface.getZoomX());
		this.zoomFieldX.setHorizontalAlignment(JTextField.TRAILING);
		this.zoomFieldX.setBorder(BorderFactory.createEmptyBorder(5, 5, 5, 5));
		
		this.zoomFieldY = new JLabel();
		this.zoomFieldY.setText(""+this.drawSurface.getZoomY());
		this.zoomFieldY.setHorizontalAlignment(JTextField.TRAILING);
		this.zoomFieldY.setBorder(BorderFactory.createEmptyBorder(5, 5, 5, 5));
		
		// X-zoomaus-paneeli:
		JPanel zoomX = new JPanel();
		zoomX.setLayout(new BoxLayout(zoomX, BoxLayout.LINE_AXIS));
		zoomX.add(new JLabel(" x: "));
		zoomX.add(this.zoomOutX);
		zoomX.add(Box.createHorizontalGlue());
		zoomX.add(this.zoomFieldX);
		zoomX.add(this.zoomInX);
		zoomX.setAlignmentX(Component.CENTER_ALIGNMENT);
		//zoomX.setBorder(BorderFactory.createTitledBorder("x"));
		zoomX.setBorder(BorderFactory.createEmptyBorder(5, 0, 5, 0));
		
		// Y-zoomaus-paneeli:
		JPanel zoomY = new JPanel();
		zoomY.setLayout(new BoxLayout(zoomY, BoxLayout.LINE_AXIS));
		zoomY.add(new JLabel(" y: "));
		zoomY.add(this.zoomOutY);
		zoomY.add(Box.createHorizontalGlue());
		zoomY.add(this.zoomFieldY);
		zoomY.add(this.zoomInY);
		zoomY.setAlignmentX(Component.CENTER_ALIGNMENT);
		//zoomY.setBorder(BorderFactory.createTitledBorder("y"));
		zoomY.setBorder(BorderFactory.createEmptyBorder(5, 0, 5, 0));
		
		// kuvasuhteen silyttmisen valintaruutu
		this.keepRatio = new JCheckBox("Silyt kuvasuhde");
		this.keepRatio.setAlignmentX(Component.CENTER_ALIGNMENT);
		this.keepRatio.setSelected(true);
		
		// Normalisoi-nappi
		this.reset = new JButton("Normalisoi nkym");
		this.reset.addActionListener(this);
		this.reset.setAlignmentX(Component.CENTER_ALIGNMENT);
		//this.reset.setAlignmentX(Component.RIGHT_ALIGNMENT);
		
		// Suurennospaneeli
		JPanel zoomPanel = new JPanel();
		zoomPanel.add(zoomX);
		zoomPanel.add(zoomY);
		zoomPanel.add(this.keepRatio);
		zoomPanel.add(this.reset);
		zoomPanel.add(Box.createHorizontalGlue());
		zoomPanel.setLayout(new BoxLayout(zoomPanel, BoxLayout.PAGE_AXIS));
		zoomPanel.setBorder(BorderFactory.createTitledBorder("Suurennos"));
		zoomPanel.setAlignmentX(Component.CENTER_ALIGNMENT);
		
		
		// Tyhjenn-nappi
		this.clear = new JButton("Tyhjenn");
		this.clear.addActionListener(this);
		this.clear.setAlignmentY(Component.TOP_ALIGNMENT);
		this.clear.setAlignmentX(Component.CENTER_ALIGNMENT);
		
		// Sisltpaneeli
		JPanel contentsPanel = new JPanel();
		contentsPanel.add(this.clear);
		contentsPanel.add(Box.createHorizontalGlue());
		contentsPanel.setLayout(new BoxLayout(contentsPanel, BoxLayout.PAGE_AXIS));
		contentsPanel.setBorder(BorderFactory.createTitledBorder("Sislt"));
		contentsPanel.setAlignmentX(Component.CENTER_ALIGNMENT);
		
		// oikean reunan hallintapaneeli (suurennos- ja sisltpaneeli)
		this.controlPanel = new JPanel();
		this.controlPanel.add(zoomPanel);
		this.controlPanel.add(Box.createRigidArea(new Dimension(0, 10)));
		this.controlPanel.add(contentsPanel);
		this.controlPanel.add(Box.createVerticalGlue());
		
		this.controlPanel.setLayout(new BoxLayout(this.controlPanel, BoxLayout.PAGE_AXIS));
		this.controlPanel.setAlignmentY(Component.TOP_ALIGNMENT);
		this.controlPanel.setBorder(BorderFactory.createEmptyBorder(0, 5, 0, 0));
		
		// sdetn this kuntoon
		this.add(this.drawSurface);
		this.add(this.controlPanel);
		this.setLayout(new BoxLayout(this, BoxLayout.LINE_AXIS));
		this.setAlignmentX(Component.RIGHT_ALIGNMENT);
	}
	
	/**
	 * Lis funktion piirrettvksi.
	 * @param f		listtv funktio
	 */
	public void addFunction(FuncXtoY f) {
		this.drawSurface.addFunction(f);
	}
	
	
	/**
	 * Kyttjn toimenpiteiden prosessointi. Tt kutsutaan jos kyttj tekee jotain
	 * (=painaa nappia) hallintapaneelissa.
	 * @param e		aiheutunut tapahtuma
	 */
	public void actionPerformed(ActionEvent e) {
		// tyhjennys
		if( e.getSource().equals(this.clear) )
			this.drawSurface.clear();
		
		// x-suurennos
		if( e.getSource().equals(this.zoomInX) ) {
			this.drawSurface.setZoomX(this.drawSurface.getZoomX() * 2);
			if( this.keepRatio.isSelected() )
				this.drawSurface.setZoomY(this.drawSurface.getZoomY() * 2);
		}
		
		// x-pienenns
		if( e.getSource().equals(this.zoomOutX) ) {
			this.drawSurface.setZoomX(this.drawSurface.getZoomX() * .5);
			if( this.keepRatio.isSelected() )
				this.drawSurface.setZoomY(this.drawSurface.getZoomY() * .5);
		}
		
		// y-suurennos
		if( e.getSource().equals(this.zoomInY) ) {
			this.drawSurface.setZoomY(this.drawSurface.getZoomY() * 2);
			if( this.keepRatio.isSelected() )
				this.drawSurface.setZoomX(this.drawSurface.getZoomX() * 2);
		}
		
		// y-pienenns
		if( e.getSource().equals(this.zoomOutY) ) {
			this.drawSurface.setZoomY(this.drawSurface.getZoomY() * .5);
			if( this.keepRatio.isSelected() )
				this.drawSurface.setZoomX(this.drawSurface.getZoomX() * .5);
		}
		
		// normalisointi
		if( e.getSource().equals(this.reset) ) {
			this.drawSurface.setZoomX(1.0);
			this.drawSurface.setZoomY(1.0);
		}
		
		// pivitetn suurennokset
		this.zoomFieldX.setText("" + this.drawSurface.getZoomX());
		this.zoomFieldY.setText("" + this.drawSurface.getZoomY());
	}
}
