package funktiopiirturi;

import javax.swing.*;
import java.awt.*;
//import java.awt.event.*;


/**
 * Funktiopiirturi on muotoa y = f(x) olevien yhden muuttujan funktioden piirtmiseen
 * tarkoitettu ohjelma. Ohjelmaa ei ole tarkoitettu funktioiden kulun tarkaan analysointiin,
 * vaan yleiskuvan saamiseen tarkasteltavista funktioista.
 * @author Teppo Niinimki
 */
public class Funktiopiirturi {
	private FunctionShowPanel outputPanel;
	private FunctionInputPanel inputPanel;
	private JPanel mainPanel;
	private JFrame frame;
	
	/**
	 * Pmetodi. Tehdn asia "oikealla" tavalla: luodaan uusi funktiopiirturi uudessa
	 * sikeess.
	 * @param args	ohjelman saamat parametrit, ei vaikutusta
	 */
	public static void main(String[] args) {
		SwingUtilities.invokeLater(new Runnable() {
			public void run() {
				//Funktiopiirturi fp = new Funktiopiirturi();
				new Funktiopiirturi();
			}
		});
	}
	
	/**
	 * Virheellisen kyttjsytteen sattuessa funktioiden syttpaneeli kutsuu tt
	 * pohjelman metodia, joka puolestaan ilmointtaa virheest kyttjlle dialogilla.
	 * @param message
	 */
	public void illegalInput(String message) {
		JOptionPane.showMessageDialog(this.frame, message, "Virheellinen syte!",
				JOptionPane.INFORMATION_MESSAGE);
	}
	
	/**
	 * Lis parametrina annetun funktion piirrettvksi.
	 * @param f		piirrettvksi tarkoitettu funktio
	 */
	public void addFunction(FuncXtoY f) {
		this.outputPanel.addFunction(f);
	}
	
	/**
	 * Funktiopiirturin konstruktori kokoaa kyttliittymn funktioiden syttpaneelista
	 * ja piirtopaneelista (johon sisltyy hallintapaneeli).
	 *
	 */
	private Funktiopiirturi() {
		// alapaneeli (funktion sytt)
		this.inputPanel = new FunctionInputPanel(this);
		this.inputPanel.setBorder(BorderFactory.createEmptyBorder(5, 0, 0, 0));
		
		// ylpaneeli (piirtopinta ja zoomausnapit)
		this.outputPanel = new FunctionShowPanel(this);
		
		// ppaneeli
		this.mainPanel = new JPanel();
		this.mainPanel.add(this.outputPanel);
		this.mainPanel.add(this.inputPanel);
		this.mainPanel.setBorder(BorderFactory.createEmptyBorder(5, 5, 5, 5));
		this.mainPanel.setLayout(new BoxLayout(this.mainPanel, BoxLayout.Y_AXIS));
		this.mainPanel.setMinimumSize(new Dimension(64, 64));
		this.mainPanel.setPreferredSize(new Dimension(600, 500));
		
		// p-frame
		this.frame = new JFrame("Funktiopiirturi");
		this.frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);	// lopetetaan ruksista
		this.frame.getContentPane().add(mainPanel);
		this.frame.pack();
		this.inputPanel.requestFocus();		// fokus aluksi funtioiden syttkenttn
		this.frame.setVisible(true);
		
		// virheilmoitustestej
	}
}
